// ITK
#include "itkBinaryThresholdImageFilter.h"
#include "itkImageFileReader.h"
#include "itkImageFileWriter.h"
#include "itkNumericSeriesFileNames.h"
#include <itkBinaryMaskToNarrowBandPointSetFilter.h>
#include <itkPointSet.h>
#include <itkAddImageFilter.h>
#include <itkBinaryThresholdImageFilter.h>
#include "itkNumericTraits.h"
#include "itkCastImageFilter.h"
#include "itkImageDuplicator.h"
//#include "itkPointSetToImageFilter.h"
#include "itkBSplineScatteredDataPointSetToImageFilter.h"
#include "itkFastMarchingImageFilter.h"
#include "itkImageRegionIterator.h"
#include <itkOtsuMultipleThresholdsCalculator.h>
// VNL
#include "vnl/vnl_sample.h"
#include <float.h> //for DBL_MIN

const   unsigned int        Dimension = 3;
const unsigned int D=1;
typedef unsigned short      PixelType;
typedef itk::Image< PixelType, Dimension >    ImageType;
typedef double               FloatPixelType;
typedef itk::Image< FloatPixelType, Dimension > FloatImageType;
typedef itk::ImageFileReader< ImageType > ReaderType;

const int DataDimension = 0;
typedef itk::Vector < double , D > VectorType ;
typedef itk::Image < VectorType , Dimension > VectorImageType ;
typedef itk::ImageFileWriter<  itk::Image<float,Dimension>  > WriterType;


typedef itk::PointSet<  VectorImageType :: PixelType, Dimension >       PointSetType;
typedef itk::BinaryMaskToNarrowBandPointSetFilter< ImageType, PointSetType>  NarrowBandFilterType;
typedef itk::BinaryThresholdImageFilter<FloatImageType, ImageType> BinaryThresholdImageFilterType;
typedef itk::CastImageFilter< ImageType, FloatImageType> Cast2FloatImageFilterType;
typedef itk::BinaryThresholdImageFilter<FloatImageType, ImageType> ThresholdImageFilterType;

const int GMMPointDimension = Dimension + DataDimension;
typedef vnl_vector_fixed < double , GMMPointDimension > VNLPointType;
typedef vnl_vector_fixed < double, Dimension > XYZPointType;
typedef vnl_matrix_fixed<double, Dimension, Dimension> RotationMatrixType;
typedef PointSetType::PointType PointType;
typedef PointSetType::PointsContainer PointsContainer;
typedef PointsContainer::Iterator PointsIteratorType;
typedef vnl_matrix_fixed <double, GMMPointDimension, GMMPointDimension> AffineMatrixType;
typedef vnl_vector_fixed <double, GMMPointDimension> TranslationType;
typedef vnl_matrix< double > PosteriorsMatrixType;
typedef std::vector< PosteriorsMatrixType > PosteriorsMatrixVectorType;
typedef std::vector< AffineMatrixType > AffineMatrixVectorType;
typedef std::vector< TranslationType > TranslationVectorType;
typedef std::vector< double > PriorsVectorType;
typedef std::vector< VNLPointType > VNLPointVectorType;
typedef std::vector<PointSetType::Pointer> PointSetVectorType;



#define MYEPS DBL_MIN
