function SimulateData(outputDirName,meshListFileName, K, N, M, D, V, r, t)
% outputDirName output directory name to hols point set files
% meshListFileName: output point sets list file name
% K is the number of point sets
% N is the number of points on each set 
% M is the number of model points (components)
% D is the dimension of the points (default is 4)
% V is the variance of the Gaussian components 
% r if set, each generated point set will be rotated (default is 0)
% t if set, each generated point set will be translated (defualt is 0)

%first create a local dir to save results
mkdir(outputDirName);
cd(outputDirName);
fidPointSetList = fopen(meshListFileName,'w');

va = V*eye(D,D);
%if (D == 4)
%    va(4,4) = va(4,4)*.01; %this the level set values variance, must be small compated to location variance
%end
tmpVa = va;
mu = [100*rand(1,D-1), 0];

for m=1:M-1
    mu = [mu; 100*rand(1,D-1),0];
    va = cat(3,va,tmpVa);
end

p = ones(1,M)/M;
%this is my model
obj = gmdistribution(mu,va,p);


for i=1:K
    pointSetName=sprintf('%s/x_%02d.txt',pwd,i);
    %writing the file name to the list
    fprintf(fidPointSetList,'%s\n',pointSetName); 
    %making samples
    x=random(obj,N);
    format = '%f '; 
    for d=1:D-1
        format = [format '%f '];
    end
    format = [format '\n'];
    fid = fopen(pointSetName,'w');
    fprintf(fid,format,x');
    fclose(fid);
end

fclose(fidPointSetList);
cd ../
end