function [d dMax] = crossValidateSpecificity(inputMeshFilesList, outputDirName, N,S)
% N is the total number of shapes
% S is the number of leave out samples


%first create a local dir to save results
mkdir(outputDirName);
cd(outputDirName);

%then read available mesh file names and save them in an array
fidMeshFiles = fopen(inputMeshFilesList,'r');
for i = 1:N
    inputMeshNames(i,:) = fscanf(fidMeshFiles, '%s',1);
end
fclose(fidMeshFiles);
%

numIter = N/min(S,N-S);
M=N-S; %number of modes
%M=2;
R=20; %number of random samples per model
for  i = 1:numIter
    %list of algined training point sets
    trainAlgList = sprintf('trainAlgList_%02d.txt',i);
        
    %pca file
    pcaModel = sprintf('pcaModel_%02d.txt',i);
    
    %now generating 10 sample shapes using M modes of variations
    
    for k = 1:R
        b = randn([M,1]); b(b>3)=3; b(b<-3)=-3;
        %writing vector b into a file
        bFid = fopen('randB.txt','w');
        fprintf(bFid,'%f ',b);fprintf(bFid,'%\n',b);
        fclose(bFid);
        %now generating a random shape
        com=sprintf('demoVariation -p %s -b randB.txt -o randVar',pcaModel);
        system(com,'-echo');
        
        %first make a list file with N-S repeatition of of randVar_001.txt
        refListFid = fopen('randRefList.txt','w');
        for l=1:N-S
            fprintf(refListFid,'%s/randVar_001.txt\n',pwd);
        end
        fclose(refListFid);
        %now measuring the distance of the random shapes from the training
        com = sprintf('distanceOfPointSets -r %s -i randRefList.txt -n %d -o randDist.txt -m randMaxDists.txt', trainAlgList,  N-S);
        system(com,'-echo'); 
        
        fidMaxDists = fopen('randMaxDists.txt','r');
        for j = 1:N-S
            dmax(j) = fscanf(fidMaxDists,'%f',1);
        end
        dMax(k,i) = min(dmax(:));
        fclose(fidMaxDists);
        
        
        %com=sprintf('rm -rf rand*');
        %system(com,'-echo');
    end
    
        
      
end
cd ../

d=[];
end
