function [nii,FV]=niiImageToSurface(inputImage,isolevel)
%nii = load_nii(inputImage);
nii = load_untouch_nii(inputImage);
data = permute(nii.img,[2,1,3]);
[nx ny nz]= size(nii.img); %#ok<*NCOMMA>
dim = nii.hdr.dime.pixdim(2:4);
dx=dim(1);
dy=dim(2);
dz=dim(3);

M(1,:)= nii.hdr.hist.srow_x;
M(2,:)= nii.hdr.hist.srow_y;
M(3,:)= nii.hdr.hist.srow_z;


y=M(2,2)*(0:ny-1)+M(2,4);
x=M(1,1)*(0:nx-1)+M(1,4);
z=M(3,3)*(0:nz-1)+M(3,4);

%[x0,y0,z0] = meshgrid(dy*(0:ny-1), dx*(0:nx-1),  dz*(0:nz-1));
[x0,y0,z0] = meshgrid(-x,-y,z);
FV = isosurface(x0,y0,z0,data,isolevel ,'noshare');
p = patch(isosurface(x0,y0,z0,data,isolevel ,'noshare'));
isonormals(x0,y0,z0,data,p)
isonormals(x0,y0,z0,data,p)
set(p,'FaceColor',[1 0 0],'EdgeColor','none');
daspect([1 1 1])
axis tight
camlight 
lighting gouraud
lighting phong
lighting flat
alpha(1.0);
box on;
camproj('perspective')
grid on;
view(45, 45)
end