function plotBar(d, zmin, dz, ymin, ymax, cl, ylab, zlab)

[m n ] = size(d);
z = 0:(n-1);
if ( zlab == '$N_M$' )
    z=(n-1):-1:0;
end
z = zmin + dz*z;   
% n is the number of increments in z


Y = mean(d,1);
E = std(d,1);

errorbar(z,Y,E,cl,'MarkerSize',14,'LineWidth',2),hold on

set(gca, 'FontWeight','b')


%set(gcf,'Position',[100 100 800 800])
%set(gca,'Position',[0.09 0.08 .89 .91],'FontSize',18,'FontWeight','b')
set(gcf,'Position',[100 100 1100 800]) %for specificity graphs
set(gca,'Position',[0.09 0.08 .89 .91],'FontSize',18,'FontWeight','b') %for specificity graphs

ylim([ymin ymax])
xlim([zmin zmin+(n-1)*dz])

box on
grid on


if ( zlab == '$N_M$' )
  %set(gca,'XTickLabel',{'4100','3500','3000','2500','2000','1500','1000','500','100'},'fontsize',20,'fontweight','b')
  set(gca,'XTick',zmin:dz:zmin+(n-1)*dz)
  %set(gca,'XTickLabel',{'3700','3300','2900','2500','2100','1700','1300','900','500','100'},'fontsize',20,'fontweight','b') %for caudate 
  set(gca,'XTickLabel',{'4100','3700','3300','2900','2500','2100','1700','1300','900','500','100'},'fontsize',20,'fontweight','b') %for prostate 
  %set(gca,'XTickLabel',{'3300','2900','2500','2100','1700','1300','900','500','100'},'fontsize',20,'fontweight','b') %for hippocampus
  xlabel(zlab,'fontsize',20,'fontweight','b','Interpreter','latex')
  %set(gca,'XTickLabel',,'fontsize',5,'fontweight','b')
else
   xlabel(zlab,'fontsize',20,'fontweight','b','Interpreter','latex')
end

if ( ylab == 'hd' )
    ylabel('Hausdorff Distance(mm)','fontsize',20,'fontweight','b','Interpreter','latex')
elseif (ylab == 'sd')
    ylabel('Surface Distance(mm)','fontsize',20,'fontweight','b','Interpreter','latex')
elseif (ylab == 'nm')
     ylabel('Number of Model Points','fontsize',20,'fontweight','b','Interpreter','latex')
elseif (ylab == 'sp')
     ylabel('Sparsity $\%$','fontsize',20,'fontweight','b','Interpreter','latex')
elseif (ylab == 'cp')
     ylabel('Trace of Covariance (Log)','fontsize',20,'fontweight','b','Interpreter','latex')
%ylabel('Probability(Log)','fontsize',16,'fontweight','b','Interpreter','latex')
end
    
end