function renderVariationOnSurface(inputImage,varImage,a,isolevel)
nii = load_nii(inputImage);
var = load_nii(varImage);
data = nii.img;
varData = var.img;

[nx ny nz]= size(nii.img);
dim = nii.hdr.dime.pixdim(2:4);
dx=dim(1);
dy=dim(2);
dz=dim(3);



[x0,y0,z0] = meshgrid(dy*(0:ny-1), dx*(0:nx-1), dz*(0:nz-1));
[f,v]=isosurface(x0,y0,z0,data,isolevel,'noshare');
p = patch('Vertices',v,'Faces',f);
isonormals(x0,y0,z0,data,p);

VI = interp3(x0,y0,z0,varData,v(:,1),v(:,2),v(:,3));
minVI = min(VI);
maxVI = max(VI);
cmap=colormap(jet(128));
[nCL,c]=size(cmap);
VI = round((VI-minVI)*(nCL-1)/(maxVI-minVI))+1;
[nV,c]=size(VI);
for i=1:nV
  cdata(i,:) = cmap(VI(i),:);
end
set(p,'FaceColor','interp','FaceVertexCData',cdata,'EdgeColor','none');

daspect([1 1 1])
view(-150, 20)%view(30, 20); 
camlight 
lighting gouraud
material default 
alpha(0.8);
box on;
camproj('perspective')
grid on;
colorbar('location','South','Position',[.5 .93 .45 .02])
%colorbar('Position',[3,5, 630, 470] )
caxis([minVI,maxVI])
if (~isempty(a))
    axis(a)
else
    axis([40 120 0 80 55 95])
end
set(gcf, 'Color',[1 1 1])
%axis tight
set(gca, 'Units', 'normalized', 'Position', [0.05 0.05 0.95 0.95])
