#!/usr/bin/python
import getopt, sys, os, commands, shutil

def usage():
    print "\nUsage:\n"
    print "Converts point sets in a list to level images and computes Dice ratios."
    print "\tComputeDiceForMeshList -i input_pointset_list -r reference_pointset -o output_image_list -d output_dices_list -n number_of_meshes -t template_image\n"
    print "\tOptions:"
    print "\t-s scale used for imge generation"

    
    
def main():
    try:
        opts, args = getopt.getopt(sys.argv[1:], "hvi:o:r:d:n:t:s:", [])
    except getopt.GetoptError, err:
        # print help information and exit:
        print str(err) # will print something like "option -a not recognized"
        usage()
        sys.exit(2)
    outputDir = os.getcwd()
    verbose = False
    outputDir = os.path.realpath(outputDir)
    
    outputImageList = ""
    inputFileList = ""
    templateImage = ""
    refImage = ""
    rOpts = 0
    n = 0
    s = " 4 "
    for o, a in opts:
        if o == "-v":
            verbose = True
        elif o in ("-h", "--help"):
            usage()
            sys.exit()
        elif o in ("-o"):
            outputImageList = a
            rOpts +=1
        elif o in ("-i"):
            inputFileList = a
            rOpts +=1
        elif o in ("-r"):
            refPointSet = a
            rOpts +=1
        elif o in ("-n"):
            n = int(a)
            rOpts +=1
        elif o in ("-d"):
            outputDiceList = a
            rOpts +=1
        elif o in ("-t"):
            templateImage = a
            rOpts +=1
        elif o in ("-s"):
            s = a
        else:
            assert False, "unhandled option"
   
    if (rOpts != 6):
        usage()
        print "Please specify all required inputs.\n"
        sys.exit(2)

    fileNames = " "
    if os.path.exists(inputFileList):
        inputList = open(inputFileList)
        fileNames = inputList.readlines()
    else:
        print "Can not find input file list: "+inputFileList
 
    if not os.path.exists(templateImage):
        print "Can not find templateImage: "+templateImage

    if not os.path.exists(refPointSet):
        print "Can not find input reference: "+refPointSet
    #make a reference image
    refImage=outputDir+"/"+os.path.splitext(os.path.basename(refPointSet))[0]+".hdr"
    com="PointSetToImage "+refPointSet+" "+refImage+" "+templateImage+" "+s+" 1 "
    os.system(com)
        

    cnt=0
    outputList = open(outputDir+"/"+outputImageList,'w')
    ofile = open(outputDir+"/"+outputDiceList,'w')


    for eachF in fileNames:
        if not (os.path.exists(eachF.strip())):
            print "Can not find input mesh: " + eachF
            continue
        eachF = os.path.realpath(eachF)
        eachO = outputDir+"/"+os.path.splitext(os.path.basename(eachF))[0]+".hdr"
        outputList.write(eachO+"\n")
        #make an image
        com="PointSetToImage "+eachF.strip()+" "+eachO+" "+refImage+" "+s
        print com
        os.system(com)
        #make cap
        tmpCap=outputDir+"/tmpCap.hdr"
        com="3dcalc "+" -a "+eachO+" -b "+refImage+" -expr '2*ispositive(a)*ispositive(b)' "+" -prefix "+tmpCap
        print com
        os.system(com)
        tmpCup=outputDir+"/tmpCup.hdr"
        #make cup
        com="3dcalc "+" -a "+eachO+" -b "+refImage+" -expr 'ispositive(a)+ispositive(b)' "+" -prefix "+tmpCup
        print com
        os.system(com)
        print "computing dice..."
        com = "fslstats "+tmpCap+" -m "
        stat, num= commands.getstatusoutput(com)
        com = "fslstats "+tmpCup+" -m "
        stat, denum= commands.getstatusoutput(com)
        dice = 100*float(num)/float(denum)
        print dice
        ofile.writelines(str(dice)+"\n")
        cnt+=1
        if (n <= cnt):
            break
        
    outputList.close()
    ofile.close()
     
 

if __name__ == "__main__":
    main()
