#!/usr/bin/python
import getopt, sys, os, commands, shutil

def usage():
    print "\nUsage:\n"
    print "Decimates mesh files independently by a desired sparsity level."
    print "\tDecimateMeshListUsingSparseModel -i input_list -o output_list -n number_of_meshes\n"
    print "\tOptions:"
    print "\t-a genericOutputFileName (default:dec)"
    print "\t-z sparsity (default:0.5)"
    print "\t-m initNm (default:10000)"
    print "\t-t genericTranFileName (default: tran)"
    
    
def main():
    try:
        opts, args = getopt.getopt(sys.argv[1:], "i:ho:va:n:t:m:z:", [])
    except getopt.GetoptError, err:
        # print help information and exit:
        print str(err) # will print something like "option -a not recognized"
        usage()
        sys.exit(2)
    outputDir = os.getcwd()
    verbose = False
    outputDir = os.path.realpath(outputDir)
    
    outputFileList = ""
    z = "0.5"
    genFileName = "dec"
    genTranName = "tran"
    rOpts = 0
    initNm = "10000"
    n = 1
    for o, a in opts:
        if o == "-v":
            verbose = True
        elif o in ("-h", "--help"):
            usage()
            sys.exit()
        elif o in ("-o"):
            outputFileList = a
            rOpts +=1
        elif o in ("-i"):
            inputFileList = a
            rOpts +=1
        elif o in ("-m"):
            initNm = a
        elif o in ("-n"):
            n = int(a)
            rOpts +=1
        elif o in ("-z"):
            z = a
        elif o in ("-a"):
            genFileName = a
        elif o in ("-t"):
            genTranName = a
        else:
            assert False, "unhandled option"
   
    if (rOpts != 3):
        usage()
        print "Please specify all required inputs.\n"
        sys.exit(2)

    fileNames = " "
    if os.path.exists(inputFileList):
        inputList = open(inputFileList)
        fileNames = inputList.readlines()
    else:
        print "Can not find input file list: "+inputFileList+"\n"
    cnt=0
    outputList = open(outputFileList,'w')
    for eachF in fileNames:
        if not (os.path.exists(eachF.strip())):
            print "Can not find input mesh: " + eachF
            continue
        eachF = os.path.realpath(eachF)
        tmplist = open("tmpList.txt",'w')
        tmplist.write(eachF)
        tmplist.close()
        #CNT = "%02d"%cnt
        #tmpModel = "model_"+CNT+".txt"
        #tmpAlg = genFileName+CNT
        #tmpTran = genTranName+CNT
        tmpModel = outputDir+"/"+os.path.splitext(os.path.basename(eachF))[0]+"_Model"+os.path.splitext(os.path.basename(eachF))[1].strip()
        tmpTran = outputDir+"/"+os.path.splitext(os.path.basename(eachF))[0]+"_Tran"+os.path.splitext(os.path.basename(eachF))[1].strip()
        #com="EstimateSparseShapeModelFromMeshFiles 1 tmpList.txt"+" "+z+" "+initNm+" "+tmpModel+" "+tmpAlg+" "+tmpTran+" "+"1"+" "+"1"+" "+"0"
        #com="EstimateSparseShapeModelFromMeshFiles 1 tmpList.txt"+" "+z+" "+initNm+" "+tmpModel+" "+genFileName+" "+genTranName+" "+"1"+" "+"1"+" "+"0"
        com="3DsparseModel -n 1 -i tmpList.txt -M "+tmpModel+" -N "+initNm+" -z "+z+" -g "+genFileName+" -t  0 "+" -r 50 "
        print com
        os.system(com)
        eachO = outputDir+"/"+os.path.splitext(os.path.basename(eachF))[0]+"_"+genFileName+os.path.splitext(os.path.basename(eachF))[1].strip()
        outputList.write(eachO+"\n")
        cnt+=1
        if (n <= cnt):
            break
        
    outputList.close()
                         
 

if __name__ == "__main__":
    main()
